JUCE: MPEZone Struct Reference

JUCE

Public Types | Public Member Functions | Static Public Member Functions | Public Attributes | Static Public Attributes | List of all members
MPEZone Struct Reference
juce_audio_basics » mpe

This struct represents an MPE zone. More...

`#include <juce_MPEZoneLayout.h>`

## Public Types
enum class | Type { lower , upper }

## Public Member Functions
| MPEZone ()=default
| MPEZone (Type type, int memberChannels=0, int perNotePitchbend=48, int masterPitchbend=2)
bool | isLowerZone () const noexcept
bool | isUpperZone () const noexcept
bool | isActive () const noexcept
int | getMasterChannel () const noexcept
int | getFirstMemberChannel () const noexcept
int | getLastMemberChannel () const noexcept
bool | isUsingChannelAsMemberChannel (int channel) const noexcept
bool | isUsing (int channel) const noexcept
bool | operator== (const MPEZone &other) const
bool | operator!= (const MPEZone &other) const

## Static Public Member Functions
static auto | tie (const MPEZone &z)

## Public Attributes
Type | zoneType = Type::lower
int | numMemberChannels = 0
int | perNotePitchbendRange = 48
int | masterPitchbendRange = 2

## Static Public Attributes
static constexpr int | lowerZoneMasterChannel = 1
static constexpr int | upperZoneMasterChannel = 16

## Detailed Description

This struct represents an MPE zone.

It can either be a lower or an upper zone, where:

- A lower zone encompasses master channel 1 and an arbitrary number of ascending MIDI channels, increasing from channel 2.
- An upper zone encompasses master channel 16 and an arbitrary number of descending MIDI channels, decreasing from channel 15.

It also defines a pitchbend range (in semitones) to be applied for per-note pitchbends and master pitchbends, respectively.

## Member Enumeration Documentation

## ◆ Type

enum class MPEZone::Type
| strong

Enumerator
lower |
upper |

## Constructor & Destructor Documentation

## ◆ MPEZone() [1/2]

MPEZone::MPEZone | ( |  | ) |
| default

## ◆ MPEZone() [2/2]

MPEZone::MPEZone | ( | Type | type,
|  | int | memberChannels = `0`,
|  | int | perNotePitchbend = `48`,
|  | int | masterPitchbend = `2`
| ) |  |

## Member Function Documentation

## ◆ isLowerZone()

bool MPEZone::isLowerZone | ( |  | ) | const
| noexcept

References lower, and zoneType.

Referenced by getFirstMemberChannel(), getLastMemberChannel(), getMasterChannel(), and isUsingChannelAsMemberChannel().

## ◆ isUpperZone()

bool MPEZone::isUpperZone | ( |  | ) | const
| noexcept

References upper, and zoneType.

## ◆ isActive()

bool MPEZone::isActive | ( |  | ) | const
| noexcept

References numMemberChannels.

## ◆ getMasterChannel()

int MPEZone::getMasterChannel | ( |  | ) | const
| noexcept

References isLowerZone(), lowerZoneMasterChannel, and upperZoneMasterChannel.

Referenced by isUsing().

## ◆ getFirstMemberChannel()

int MPEZone::getFirstMemberChannel | ( |  | ) | const
| noexcept

References isLowerZone(), lowerZoneMasterChannel, and upperZoneMasterChannel.

## ◆ getLastMemberChannel()

int MPEZone::getLastMemberChannel | ( |  | ) | const
| noexcept

References isLowerZone(), lowerZoneMasterChannel, numMemberChannels, and upperZoneMasterChannel.

Referenced by isUsingChannelAsMemberChannel().

## ◆ isUsingChannelAsMemberChannel()

bool MPEZone::isUsingChannelAsMemberChannel | ( | int | channel | ) | const
| noexcept

References getLastMemberChannel(), isLowerZone(), lowerZoneMasterChannel, and upperZoneMasterChannel.

Referenced by isUsing().

## ◆ isUsing()

bool MPEZone::isUsing | ( | int | channel | ) | const
| noexcept

References getMasterChannel(), and isUsingChannelAsMemberChannel().

## ◆ tie()

static auto MPEZone::tie | ( | const MPEZone & | z | ) |
| static

References gl::z.

Referenced by operator!=(), and operator==().

## ◆ operator==()

bool MPEZone::operator== | ( | const MPEZone & | other | ) | const

References tie().

## ◆ operator!=()

bool MPEZone::operator!= | ( | const MPEZone & | other | ) | const

References tie().

## Member Data Documentation

## ◆ lowerZoneMasterChannel

constexpr int MPEZone::lowerZoneMasterChannel = 1
| staticconstexpr

Referenced by getFirstMemberChannel(), getLastMemberChannel(), getMasterChannel(), and isUsingChannelAsMemberChannel().

## ◆ upperZoneMasterChannel

constexpr int MPEZone::upperZoneMasterChannel = 16
| static

Referenced by getFirstMemberChannel(), getLastMemberChannel(), getMasterChannel(), and isUsingChannelAsMemberChannel().

## ◆ zoneType

Type MPEZone::zoneType = Type::lower

Referenced by isLowerZone(), and isUpperZone().

## ◆ numMemberChannels

int MPEZone::numMemberChannels = 0

Referenced by getLastMemberChannel(), and isActive().

## ◆ perNotePitchbendRange

int MPEZone::perNotePitchbendRange = 48

## ◆ masterPitchbendRange

int MPEZone::masterPitchbendRange = 2

The documentation for this struct was generated from the following file:

- juce_MPEZoneLayout.h